#!/bin/bash
#
# CMatrix Screensaver starting script
# Starts by entering the command: saver
#
# Aborts screensaver automatically on high serverload 
#
# JF Nutbroek - Version 0.01 July 2007
#

max_running_load=2.5 			# Maximum load: will stop screensaver from running
max_running_time=60			# Maximum time for screensaver to run

getload() {
 uptime=`uptime`			# Retrieve uptime info
 pattern=*average:			# Strip pattern for uptime info
 loadaverage=${uptime##$pattern}	# Strip to mere load information
 loadaverage=${loadaverage// /}		# Remove spaces
 loadaverage=${loadaverage//,/ }	# Replace , with ' '
 load=(${loadaverage})			# Convert to array
}

exit_screensaver() {
 killall cmatrix
 reset
 echo "Screensaver ended"
 exit 
}

trap exit_screensaver SIGHUP SIGINT SIGQUIT SIGKILL SIGTERM
cmatrix -lab &

timer=0
while [ 1 ]
do
 sleep 60
 timer=`expr $timer + 1`
 stop=`expr $timer \> $max_running_time`
 if [ "$stop" = "1" ]; then
  exit_screensaver
 fi
 getload
 alarm=`expr ${load[0]} \> $max_running_load`
 if [ "$alarm" = "1" ]; then
  exit_screensaver
 fi
 SERVICE="cmatrix"  
 RUNNING=`ps ax | grep -v grep | grep $SERVICE`
 if [ "$RUNNING" = "" ]; then
  exit 0
 fi
done
